/*
 * Copyright 2020 Typelevel
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package cats
package mtl
package syntax

trait RaiseSyntax {
  implicit def toRaiseOps[E](e: E): RaiseOps[E] = new RaiseOps(e)
}

final class RaiseOps[E](val e: E) extends AnyVal {
  def raise[F[_], A](implicit raise: Raise[F, E]): F[A] =
    raise.raise(e)
}

object raise extends RaiseSyntax
