/*
 * Copyright 2020 Typelevel
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package cats
package mtl
package tests

import cats.data._
import cats.laws.discipline.arbitrary._

class EitherTTests extends BaseSuite {
  import cats.mtl.laws.discipline.HandleTests

  {

    checkAll("Either[String, *]", HandleTests[Either[String, *], String].handle[Int])
    checkAll(
      "EitherT[Option, String, *]",
      HandleTests[EitherT[Option, String, *], String].handle[Int])

    checkAll(
      "WriterT[Either[String, *], Int, *]",
      HandleTests[WriterT[Either[String, *], Int, *], String].handle[Int])

    checkAll(
      "WriterT[EitherT[Option, [String, *], Int, *]",
      HandleTests[WriterT[EitherT[Option, String, *], Int, *], String].handle[Int])

  }

}
